#!/usr/local/bin/python
#
#  karel.py
#
from   runtime  import Environment
from   lang     import Lang

def readProgram(karelProgram) :
    import re
    prog = open(karelProgram).read()
    prog = re.sub("#.*"," ",prog)      # strip comments
    return re.sub(";"," ",prog)        # semicolons are optional

def readBoard(game) :
    # make into a square box
    board = open(game).readlines() # initial board
    board = [x.strip() for x in board]
    board = list(filter(lambda x: len(x)>0, board))
    width = max([len(x) for x in board])
    board = list([x.ljust(width) for x in board])
    return  list(board)

def main() :
    import sys
    game = sys.argv[1]
    startBoard = readBoard(game)
    program = readProgram(sys.argv[2])

    env = Environment(startBoard,exit)
    env.printBoard()
    prog = Lang(env, program)
    while True :
        inst = prog.getInstruction()
        if inst == "EOF" : break
        if not inst : continue
        prog.execInstruction(inst)

if __name__ == "__main__" : main()
