#
#       This module not currently part of the current project
#
import re, sys, time
from   lang      import Lang
from   runtime   import Environment, conditions

shortCuts = {}

def shortIt (short,full) :
    shortCuts[short] = full
    shortCuts[short+";"] = full+";"

def makeShortCuts() :
    cmds = conditions.keys()
    for cmd in cmds :
        words = cmd.split("-")
        abbr = "".join(map(lambda x: x[0], words))
        shortCuts[abbr] = cmd
    for w in ("BEGIN","END","ITERATE","TIMES","WHILE","DO","IF","THEN",
              "ELSE", "DEFINE-NEW-INSTRUCTION","AS") :
        shortCuts[w.lower()] = w
    shortIt('tl',"turnleft")
    shortIt('mv',"move")
    shortCuts["def"] = "DEFINE-NEW-INSTRUCTION"

def getInput() :
    words = []
    while True :
        try   : line = raw_input("Karel> ")
        except: sys.exit()
        if line and line[0] == '@' :  # file import
            line = open(line[1:].strip()).read()
        line = re.sub("#.*"," ",line)      # strip comments
        line = re.sub(";"," ",line)        # semicolons are optional
        words += line.split()
        if line == "" :
            return map(lambda x: shortCuts.get(x,x),words)

def fatal(mesg) :
    print("Fatal error: %s" % mesg)
    sys.exit()

def repl() :
    interval = .3
    initBoard = sys.argv[1]
    if len(sys.argv) > 2 : interval = float(sys.argv[2])
    exec("from %s import initBoard" % initBoard)
    env = Environment(initBoard,fatal)
    makeShortCuts()
    
    env.printBoard()
    prog = Lang(env, "")  # source supplied piecemeal
    while True :
        prog.words = getInput()     # list of words
        while True :
            inst = prog.getInstruction()
            if inst == "EOF" : break
            print("Compiled %s" % inst)
            prog.execInstruction(inst)
            env.printBoard()

if __name__ == "__main__" : repl()
